﻿@model eCommerce.BackOffice.ViewModels.CreateOrderPaymentViewModel
@using eCommerce.Services.Model.Enums
@{
    ViewBag.Title = "Cobros";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Cobro</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("CancelDebt", "OrderPayments", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off", id = "paymentForm" }))
                    {
                        <div class="row">
                            <div class="form-group">
                                <label class="col-sm-2 control-label">Fecha</label>
                                <div class="col-sm-3">
                                    <div class="input-group">
                                        <span class="input-group-addon">
                                            <i class="icon wb-calendar" aria-hidden="true"></i>
                                        </span>
                                        <input type="text" class="form-control" name="Payment.Date" value="@(DateTime.Today.ToShortDateString())" data-plugin="datepicker" />
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label">Cuenta Destino</label>
                                <div class="col-sm-9">
                                    <div class="col-sm-5" style="margin-left:-15px;">
                                        <select class="form-control" name="Payment.AccountId" id="AccountId" data-plugin="select2">
                                            @if (Model.Accounts != null)
                                            {
                                                foreach (var item in Model.Accounts)
                                                {
                                                    <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                                }
                                            }
                                        </select>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label">Observaciones</label>
                                <div class="col-sm-9">
                                    <textarea class="form-control" name="Payment.Observations" rows="2">@Model.Payment.Observations</textarea>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <label class="col-sm-2 control-label">Cheques</label>
                            <div class="col-sm-9" style="padding:0;">
                                @Html.Partial("_OrderPaymentChecks", Model.Checks)
                            </div>
                        </div>
                        <div class="row">
                            <label class="col-sm-2 control-label">Ventas</label>
                            <div class="col-sm-9" style="padding:0;">
                                @Html.Partial("_OrderPaymentOrders", Model.OrderList)
                            </div>
                        </div>
                        <div class="row text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/CustomerAccounting?id=@Model.CustomerId'">Cancelar</button>
                            <input type="hidden" name="Payment.OrderId" id="OrderId" value="@Model.Payment.OrderId" />
                            <input type="hidden" name="CustomerId" id="CustomerId" value="@Model.CustomerId" />
                            @Html.HiddenFor(model => model.Payment.TransactionId)
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>
 
    <!--MODAL CHEQUES-->
    <div class="modal fade" id="checks" aria-hidden="false" aria-labelledby="exampleFormModalLabel" role="dialog" style="overflow:hidden;">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                    <h4 class="modal-title" id="exampleFormModalLabel">Complete los siguientes datos</h4>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <form id="checksForm">
                            <div class="col-lg-12 form-group">
                                <select class="form-control" id="bankId" name="CheckBank" data-plugin="select2">
                                    <option value=""></option>
                                    @if (Model.Banks != null)
                                    {
                                        foreach (var item in Model.Banks)
                                        {
                                            <option value="@item.Value">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                            
                            <div class="col-lg-6 form-group">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="ReceivedDate" id="checkReceivedDate" data-plugin="datepicker" placeholder="Recibido" />
                                </div>
                            </div>
                            <div class="col-lg-6 form-group">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="CheckDueDate" id="checkDueDate" data-plugin="datepicker" placeholder="Vencimiento" />
                                </div>
                            </div>
                            <div class="col-lg-6 form-group">
                                <input type="text" class="form-control" name="CheckNumber" id="checkNumber" placeholder="Número de Cheque">
                            </div>
                            <div class="col-lg-6 form-group">
                                <div class="input-group">
                                    <span class="input-group-addon">$</span>
                                    <input type="text" class="form-control currency" name="CheckAmount" id="checkAmount" placeholder="Monto" value="">
                                </div>
                            </div>
                            <div class="col-sm-12 text-right">
                                <p>Número de Cheque Interno: <span id="lastCheckId"></span></p>
                            </div>
                            <div class="col-sm-12 text-right">
                                <button class="btn btn-primary btn-outline" @*data-dismiss="modal"*@ id="btnAddCheck">Agregar</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- End Modal -->
    <style type="text/css">
        .select2-close-mask {
            z-index: 2099;
        }

        .select2-dropdown {
            z-index: 3051;
        }
    </style>
</div>


@section Scripts {

    <script type="text/javascript">

        (function () {
            $('.form-horizontal').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    Date: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Fecha es requerido.'
                            }
                        }
                    },
                    AccountId: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Forma de Pago es requerido.'
                            }
                        }
                    },
                    Amount: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Monto es requerido.'
                            }
                        }
                    }
                }
            });
        })();

        $('#checksForm').formValidation({
            framework: "bootstrap",
            button: {
                selector: '#btnAddCheck',
                disabled: 'disabled'
            },
            icon: null,
            fields: {
                'CheckAmount': {
                    validators: {
                        notEmpty: {
                            message: 'El monto no puede ser vacío'
                        }
                    }
                },
                'CheckNumber': {
                    validators: {
                        notEmpty: {
                            message: 'El número de cheque no puede ser vacío'
                        }
                    }
                },
                'ReceivedDate': {
                    validators: {
                        notEmpty: {
                            message: 'La fecha recibida no puede ser vacía'
                        }
                    }
                },
                'CheckDueDate': {
                    validators: {
                        notEmpty: {
                            message: 'La fecha de vencimiento no puede ser vacía'
                        }
                    }
                },
                'CheckBank': {
                    validators: {
                        notEmpty: {
                            message: 'El banco no puede ser vacío'
                        }
                    }
                }
            }
        });

        var lastCheckId = -1;
        var originalLastCheck = -1;

        $('#checks').on('shown.bs.modal', function () {
            clearModalInputs();
            $('#checksForm').data('formValidation').resetForm();
        });

        function clearModalInputs() {
            $("#bankId").select2({
                placeholder: "Elija un banco",
                allowClear: true
            });

            $("#bankId").select2('val', '');

            $("#checkOwn").select2({
                placeholder: "Elija el dueño",
                allowClear: true
            });

            $("#checkOwn").select2('val', '');
        }

        $(document).ready(function ()
        {
            calculateChargeTotal();
            $(".currency").number(true, 2, ',', '.');

            $('#addCheckButton').click(function () {
                $.ajax({
                    url: '@Url.Action("GetLastCheckIndex", "Checks")',
                    success: function (data, textStatus, jqXHR)
                    {
                        if (lastCheckId === -1)
                        {
                            lastCheckId = data.CheckId + 1;
                        } else
                        {
                            lastCheckId++;
                        }

                        $('#lastCheckId').text(lastCheckId);
                    }
                });
            });

            $(".transaction_detail-value").change(function () {
                var total = 0;
                $(".transaction_detail-value").each(function () {
                    //debugger;
                    total += parseFloat($(this).val().replace(",", "."));
                });
                $("#transaction_total").val(total.toFixed(2));
            });

            $(".transaction_detail-value").change();

            //Crate Hiddens
            $.each($('.gradeA.check'), function (index, check) {
                addHiddenInputsForCheck(index, $(check));
            });

        });

        function calculateChargeTotal()
        {
            debugger;
            var sum = 0;

            $('.sumMoney').each(function () {
                sum += Number($(this).val().replace(',', '.'));
            });

            $('.checkAmount').each(function () {
                sum += Number($(this).text().split('$').join('').split('.').join('').replace(',', '.'));
            });

            $('#cgTotal').text(sum.toLocaleString("es-AR", { style: "currency", currency: "ARS" }));
        }

        $("#btnAddCheck").click(function (e)
        {
            debugger;
            e.preventDefault();

            var checkForm = $('#checksForm').data('formValidation');

            checkForm.validate();

            if (!checkForm.isValid()) {
                return;
            }

            var rowNumber = $("#newChecksTable tr").length - 1;
            var row =
                '<tr class="gradeA check" data-attr-amount="' + $('#checkAmount').val().replace(".", ",") + '" data-attr-workid="' + $('#checkWorkId').val() + '" data-attr-customerid="' + $('#checkCustomerId').val() + '" data-attr-bankid="' + $('#bankId').val() + '" data-attr-own="' + $('#checkOwn').val() + '" hidden="hidden" data-attr-rownumber=' + rowNumber + ' data-attr-checkNumber=' + $('#lastCheckId').text() + ' data-attr-checkId="-1" >' +
                    '<td class="receivedDate text-center">' + $('#checkReceivedDate').val() + '</td>' +
                    '<td class="checkNumber text-center">' + $('#checkNumber').val() + '</td>' +
                    '<td class="text-center">' + $('#bankId option:selected').text() + '</td>' +
                    '<td class="checkAmount text-center">$' + $('#checkAmount').val().replace(".",",") + '</td>' +
                    '<td class="dueDate text-center">' + $('#checkDueDate').val() + '</td>' +
                    '<td class="text-center"><i class="icon fa-close removeCheck" aria-hidden="true" data-attr-id=' + rowNumber + ' onclick="removeCheck(this,' + rowNumber + ');"></i></td>' +
                '</tr>';

            $("#newChecksTable").append(row);

            $('[data-attr-rownumber="' + rowNumber + '').fadeIn();

            calculateChargeTotal();

            $('#checks').modal('toggle');
        });

        function clearModalInputs()
        {
            $("#bankId").select2({
                placeholder: "Elija un banco",
                allowClear: true
            });

            $("#bankId").select2('val', '');

            $('#checks input').val('');
        }

        
        $('#btnSave').click(function (e)
        {
            e.preventDefault();

            $.each($('.gradeA.check'), function (index, check) {
                addHiddenInputsForCheck(index, $(check));
            });

            $('#paymentForm')[0].submit();
        });

        function addHiddenInputsForCheck(rowNumber, check) {
            debugger;
            addHiddenInput('RecievedDate', rowNumber, check.find('.receivedDate').text());
            addHiddenInput('CheckId', rowNumber, check.attr('data-attr-checkId'));
            addHiddenInput('DueDate', rowNumber, check.find('.dueDate').text());
            addHiddenInput('Amount', rowNumber, check.data('attr-amount'));
            addHiddenInput('Number', rowNumber, check.find('.checkNumber').text());
            addHiddenInput('BankId', rowNumber, check.data('attr-bankid'));
            addHiddenInput('WorkId', rowNumber, check.data('attr-workid'));
            addHiddenInput('CustomerId', rowNumber, check.data('attr-customerid'));
            addHiddenInput('Own', rowNumber, check.data('attr-own'));
            addHiddenInput('Active', rowNumber, true);
        }

        function addHiddenInput(identifier, rowNumber, value) {

            $('<input>').attr({
                type: 'hidden',
                name: 'Checks[' + rowNumber + '].' + identifier,
                id: 'Checks_' + rowNumber + '__' + identifier,
                class: 'Checks_' + rowNumber,
                value: value
            }).appendTo('form');
        }

        function checkCancelDebt(idCancelar) {
            debugger;
            if ($('#cancelarDeuda_' + idCancelar).is(":checked")) {
                $('#OrderAmountToPay_' + idCancelar).val($('#PendingAmountToPay_' + idCancelar).val());
            }
            else {
                $('#OrderAmountToPay_' + idCancelar).val("0");
            }
            $('#OrderAmountToPay_' + idCancelar).change();
        }

        function removeCheck(check, rowNumber) {
            var checkId = $(check).data('attr-id');
            var checkRow = $(check).parent().parent();

            debugger;
            $("input[name*='Checks[" + rowNumber + "].Active']").val(false);
            
            checkRow.fadeOut("slow", function () {
                checkRow.remove();
                /*$('.Checks_' + rowNumber).each(function () {
                    $(this).remove();
                });*/
                calculateChargeTotal();
            });
        }



    </script>


}

